// Pecon7
// Player downing - Instead of instantly dieing, you go down first; given you weren't get completely annihilated.
// Inspired from the mechanics in Rotondo's zombie mod.

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");

	//prefs
	RTB_registerPref("Enabled","Player Downing","PlayerDowning::Enabled","bool","Script_Downed",true,0,1);
	RTB_registerPref("Enabled outside minigames","Player Downing","PlayerDowning::EnabledOutsideMinigames","bool","Script_Downed",false,0,1);
}
else
{
	//Set prefs here manually if you do not have RTB.
	$pref::PlayerDowning::Enabled = 1;
	$pref::PlayerDowning::EnabledOutsideMinigames = 1;
}

//If you think any of these other ones need to be RTB Prefs, you should tell me.
$pref::PlayerDowning::DownedPlayerBleed = -3;
$pref::PlayerDowning::DownedPlayerScheduleTimer = 500;
$pref::PlayerDowning::DownedPlayerHP = 100;
$pref::PlayerDowning::DownedPlayerWeaponImage = DownedPistolImage;

// Initiate the datablock with prefs
datablock PlayerData(DownedPlayerArmor : PlayerStandardArmor)
{
	maxForwardSpeed = 0;
	maxBackwardSpeed = 0;
	maxSideSpeed = 0;
	drag = 0.7;
	density = 0.7;
	maxForwardCrouchSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;
	jumpforce = 0;
	canJet = 0;
	uiName = '';
	maxDamage = $pref::PlayerDowning::DownedPlayerHP;
	cantbedowned=1;
};

datablock ShapeBaseImageData(DownedPistolImage : GunImage)
{
	shapeFile = "Add-ons/Weapon_Gun/pistol.dts";
	stateTimeoutValue[2]	= 0.5;
	stateTimeoutValue[3]	= 0.5;
	stateTimeoutValue[4]	= 0.5;
	armReady = false;
};

package playerDowning
{
	
	function player::damage(%this, %obj, %pos, %directDamage, %damageType)
	{
		if(%this.getType() & $TypeMasks::PlayerObjectType)
		{
			//echo(Damage);
			if(!$pref::PlayerDowning::EnabledOutsideMinigames || !isObject(%this.client.minigame))
			{
				parent::damage(%this, %obj, %pos, %directDamage, %damageType);
			}
			//echo(minigame);
			if(!%this.getDataBlock().cantbedowned && $pref::PlayerDowning::Enabled && !%this.isDowned)
			{
				//echo(enabled);
				if(%this.getdatablock().maxdamage-%this.getdamagelevel() < %directdamage && !$pref::PlayerDowning::DownedPlayerHP < %directdamage)
				{
					%this.changeDatablock(DownedPlayerArmor);
					%this.setHealth($pref::PlayerDowning::DownedPlayerHP);
					%this.isDowned = true;
					%this.playThread(0, death1);
					%this.client.centerPrint("You've been downed!",3);
					//echo(done);
					downedDeathLoop(%this);
				}
			}
		}
		//echo(%directdamage SPC %damageType);
		parent::damage(%this, %obj, %pos, %directDamage, %damageType);
	}
	

	function DownedPlayerArmor::onAdd(%this,%obj)
	{
		%obj.playthread(0,death1);
		parent::onAdd(%this,%obj);
	}
	
	function player::Mountimage(%this, %image, %slot)
	{
		if(%image $= $pref::PlayerDowning::DownedPlayerWeaponImage)
		{
			parent::Mountimage(%this, %image, %slot);
			return;
		}
	
		if(%this.isdowned)
		{
			%this.mountImage($pref::PlayerDowning::DownedPlayerWeaponImage, 0);
			return;
		}
		parent::MountImage(%this, %image, %slot);
	}
	
	function DownedPlayerArmor::onMount(%a,%player,%vehicle,%d,%e,%f)
	{
		if(%player.ispilot() && %player.isDowned)
		{
			Armor::DoDismount(%player.getdatablock(),%player);
			return;
		}
		Parent::onMount(%a,%player,%vehicle,%d,%e,%f);
	}
};
activatepackage(playerDowning);


function downedDeathLoop(%player)
{
	%player.addhealth($pref::PlayerDowning::DownedPlayerBleed);
	schedule($pref::PlayerDowning::DownedPlayerScheduleTimer, %player, downedDeathLoop, %player);
}